function log_stream(element, logUrl) {
	element.innerText = "";
	
	function fetchMore() {
		fetch(logUrl + "&from=" + element.innerText.length)
			.then(response => response.text())
			.then(jsonStr => {
				let json = JSON.parse(jsonStr);
			
				element.innerText += json.new_output;
			
				const scrollOffset = 60;
				const bodyTop = document.body.getBoundingClientRect().top;
				const viewportHeight = window.innerHeight;
				const elementBottom = element.getBoundingClientRect().bottom;

				window.scrollTo({
				  top: elementBottom - viewportHeight - bodyTop + scrollOffset
				});
			
				if(json.task_finished) {
					let validationButtonId = element.getAttribute('data-validation-button-id');
					if(validationButtonId) {
						document.getElementById(validationButtonId).classList.remove('disabled', false);
					}
				}
				else {
					setTimeout(fetchMore, 100);
				}
			});
	}
	
	fetchMore();
}
